###################### How to save an object using saveRDS() ################################## 
###############################################################################################

#First, it's important to set the right working directory
##  Use the setwd() function to set the right path to your SaveRDS file

setwd("/path example/SaveRDS")  #replace 'path example' with your own path

#In order to save a function and call it, you need to create one or use a pre-existing one.

#We are going to create our own function


##### 1. Create a basic function ##########################

myFunction <- function(x){
  #x <- x*x     #This function takes a numerical value x in argument and returns its value to the square.
  return(x)     #Feel free to replace it with another function of your choice (remove the '#' to make it work)
}

myFunction(x)   #Test your function by giving a numerical value to x.


#### 2. Save your function into an .rds file ##########################

#You are going to use the saveRDS() command in order to save your function into the savedObject folder.

saveRDS(myFunction, 
        file = "savedObject/YourFunctionName.rds") #You can keep the same function name or change it.
                                                   #Don't forget the .rds extension 



#### 3. Read your previously saved function ##########################

#Now that we created a function and saved it in the savedObject Folder, we can read our function back in R
#using the readRDS() function.

#Firstly, we assign an new object to our function
mySavedFunction <- readRDS(file = "savedObject/YourFunctionName.rds") #It is important to use the same path that you  
                                                                      #used to save your function otherwise it won't work

#your previously saved function can be used under its new name.
mySavedFunction(x)#test again your function to insure it work properly (replace x with an integer).
