#Exercises - Solution

# Load xts
library(xts)

#View the structure of AirPassengers time series data
str(AirPassengers)
AirPassengers

#Convert it to a XTS object
AP.xts <- as.xts(AirPassengers)

#Method 1
#Use endpoint() to find indices of the last observations in each interval
ep.quarter <- endpoints(AP.xts, on="quarters", k=1)
ep.year <- endpoints(AP.xts, on="years", k=1)

#Use period.apply() to perform aggregation
quarterlymean <- period.apply(AP.xts, INDEX = ep.quarter, FUN = mean)
quarterlysd <- period.apply(AP.xts, INDEX = ep.quarter, FUN = sd)
yearlymean <- period.apply(AP.xts, INDEX = ep.year, FUN = mean)
yearlysd <- period.apply(AP.xts, INDEX = ep.year, FUN = sd)

#Method 2
#Split time series data into non-overlapping chunks
AP.quarterly <- split(AP.xts, "quarters")
AP.yearly <- split(AP.xts, "years")

#Use lapply() to perform aggregations on these periods
quarterlymean <- do.call(rbind, lapply(AP.quarterly, mean))
quarterlysd <- do.call(rbind, lapply(AP.quarterly, sd))
yearlymean <- do.call(rbind, lapply(AP.yearly, mean))
yearlysd <- do.call(rbind, lapply(AP.yearly, sd))
