Tabbats <- read.table("Tabbats.txt", header = TRUE,      #header = TRUE, means that we use 
                      stringsAsFactors = FALSE)
Tabbats <- Tabbats[,(4:8)]

maxs <- apply(Tabbats, 2, max)
mins <- apply(Tabbats, 2, min)
scaled <- as.data.frame(scale(Tabbats, center = mins, scale = maxs - mins))  
# min-max normalization

#scaled <- as.data.frame(scale(Tabbats, center = TRUE, scale = TRUE)) 
# z-score nomorlization, using colMeans as center value, and scale each value 
# with standard deviation of each column

indarr <- sample(1:nrow(scaled),round(0.8*nrow(scaled))) 
train <- scaled[indarr,] 
test <- scaled[-indarr,]

#install.packages("neuralnet")
library(neuralnet)
f <- as.formula(BRW~BOW+AUD+MOB+HIP)
nn <- neuralnet(f,data=train,hidden=c(10,5,3),linear.output=T) 
#train NN with normalized training data

print(nn$result.matrix)

saveRDS(nn, 
        file = paste("NNModelP_","BRW","_","BOW-AUD-MOB-HIP",".rds",sep="") )

nn <- readRDS(file = "NNModelP_BRW_BOW-AUD-MOB-HIP.rds")

plot(nn)

predicted <- compute(nn,test) #predict the result using test data, still normalized
predicted_t <- predicted$net.result*(max(Tabbats$BRW)-min(Tabbats$BRW))+min(Tabbats$BRW) 
#result denormalizaiton

test_gt <- test$BRW*(max(Tabbats$BRW)-min(Tabbats$BRW))+min(Tabbats$BRW)
#ground truth value

print(paste(test_gt, predicted_t))